# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Plug-in DispDate
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *
from calendar import weekday

def build_plugins(pycc):
  return { \
    'dispdate': DispDate(pycc, "DispDate", "Affiche les changements de date dans le pinnipede")
  }

class DispDate(Plugin):
  
  def action_menu(self):
    cur_trib = self.pycc.bouchots[self.pycc.get_bouchot()].trib
    if cur_trib is None or not cur_trib.loaded:
      return
    if hasattr(cur_trib, 'dispdate') and cur_trib.dispdate:
      cur_trib.pinni.deleteFromTag(self.style_name)
      cur_trib.dispdate = 0
    else:
      post = cur_trib.posts[cur_trib.firstPostId]
      while post is not None:
        self.process(cur_trib.bouchot, PINNI, post)
        post = post.next
      cur_trib.dispdate = 1
  
  def get_style(self):
    return Style("[plugin] %s" % self.name, font=('Helvetica', 9, 'bold'), foreground='#008030', justify='center')
  
  def process(self, bouchot, context=PINNI, post=None, *args, **kwargs):
    if post is None:
      return
    ppost = post.prev
    if ppost is not None:
      if ppost.disp('date') == post.disp('date'):
        return
    j, m, a = map(int, post.disp('date').split('/'))
    jj = ['Lundi', 'Mardi', 'Mercredi', 'Jeudi', 'Vendredi', 'Samedi', 'Dimanche'][weekday(a,m,j)]
    mm = ['Janvier', 'Fevrier', 'Mars', 'Avril', 'Mai', 'Juin', 'Juillet', 'Aout', 'Septembre', 'Octobre', 'Novembre', 'Decembre'][m-1]
    date = "=== %s %s %s %s ===\n" % (jj, j, mm, a)
    bouchot.trib.pinni.insertFromTag("id%s" % post.id, date, {self.style_name: [(0, len(date))]})
    self.set_style_bouchot(bouchot)
    bouchot.trib.dispdate = 1
  